/**
  ${moduleNameUpperCase} Generated Driver File

  @Company
    Microchip Technology Inc.

  @Description
    This Source file provides APIs.
    Generation Information :
    Driver Version    :   1.0.0
*/
${disclaimer}

#include "../${header.name}"
#include <stdbool.h>

/**
  Section: Driver Interface
 */
const struct ${moduleGroupNameUpperCase}_CLIENT_INTERFACE ${componentNameLowerCase}_client_interface = {
    .Initialize = ${componentName}_Initialize,
    .Deinitialize = ${componentName}_Deinitialize,
    .WriteByte = ${componentName}_WriteByte,
    .ReadByte = ${componentName}_ReadByte,
    .TransferDirGet = ${componentName}_TransferDirGet,
    .LastByteAckStatusGet = ${componentName}_LastByteAckStatusGet,
    .ErrorGet = ${componentName}_ErrorGet,
    .CallbackRegister = ${componentName}_CallbackRegister,
    .Tasks = NULL
};

/**
 Section: Private functions declaration
 */
static void ${componentNameUpperCase}_EventHandler();
static void ${componentNameUpperCase}_ErrorEventHandler();
static bool ${componentNameUpperCase}_DefaultCallback(${moduleGroupNameLowerCase}_client_transfer_event_t event);

/**
 Section: Private Variable Definitions
 */
static volatile uint16_t ${componentNameLowerCase}Addr;
static volatile ${moduleGroupNameLowerCase}_client_error_t ${componentNameLowerCase}ErrorState;
static bool(*${componentNameUpperCase}_InterruptHandler)(${moduleGroupNameLowerCase}_client_transfer_event_t clientEvent) = NULL;

/**
 Section: Public functions
 */
void ${api.Initialize.name}(void)
{
    <#if CTRLA??>
    //${CTRLA.comment}
    ${moduleInstance}.${CTRLA.name} = ${CTRLA.valueAsHex};
    
    </#if>
    <#if DBGCTRL??>
    //Debug Run
    ${moduleInstance}.${DBGCTRL.name} = ${DBGCTRL.valueAsHex};
    
    </#if>
    <#if SADDR??>
    //Client Address
    ${moduleInstance}.${SADDR.name} = ${SADDR.valueAsHex};
    
    </#if>
    <#if SADDRMASK??>
    //${SADDRMASK.comment}
    ${moduleInstance}.${SADDRMASK.name} = ${SADDRMASK.valueAsHex};
    
    </#if>
    <#if SCTRLA??>
    //${SCTRLA.comment}
    ${moduleInstance}.${SCTRLA.name} = ${SCTRLA.valueAsHex};
    
    </#if>
    <#if SCTRLB??>
    //${SCTRLB.comment}
    ${moduleInstance}.${SCTRLB.name} = ${SCTRLB.valueAsHex};
    
    </#if>
    <#if SDATA??>
    //Client Data
    ${moduleInstance}.${SDATA.name} = ${SDATA.valueAsHex};
    
    </#if>
    <#if SSTATUS??>
    //${SSTATUS.comment}
    ${moduleInstance}.${SSTATUS.name} = ${SSTATUS.valueAsHex};
    
    </#if>

    ${componentName}_CallbackRegister(${componentNameUpperCase}_DefaultCallback);
}

void ${api.Deinitialize.name}(void)
{
    <#if CTRLA??>
    //${CTRLA.comment}
    ${moduleInstance}.${CTRLA.name} = 0x00;
    
    </#if>
    <#if DBGCTRL??>
    //Debug Run
    ${moduleInstance}.${DBGCTRL.name} = 0x00;
    
    </#if>
    <#if SADDR??>
    //Client Address
    ${moduleInstance}.${SADDR.name} = 0x00;
    
    </#if>
    <#if SADDRMASK??>
    //${SADDRMASK.comment}
    ${moduleInstance}.${SADDRMASK.name} = 0x00;
    
    </#if>
    <#if SCTRLA??>
    //${SCTRLA.comment}
    ${moduleInstance}.${SCTRLA.name} = 0x00;
    
    </#if>
    <#if SCTRLB??>
    //${SCTRLB.comment}
    ${moduleInstance}.${SCTRLB.name} = 0x00;
    
    </#if>
    <#if SDATA??>
    //Client Data
    ${moduleInstance}.${SDATA.name} = 0x00;
    
    </#if>
    <#if SSTATUS??>
    //${SSTATUS.comment}
    ${moduleInstance}.${SSTATUS.name} = 0x00;
    
    </#if>

    ${componentName}_CallbackRegister(${componentNameUpperCase}_DefaultCallback);
}

void ${componentName}_WriteByte(uint8_t wrByte)
{
    ${moduleNameUpperCase}.SDATA = wrByte;
}

uint8_t ${componentName}_ReadByte(void)
{
    return ${moduleNameUpperCase}.SDATA;
}

uint16_t ${componentName}_ReadAddr(void)
{
    return (${moduleNameUpperCase}.SADDR >> 1);
}

${moduleGroupNameLowerCase}_client_error_t ${componentName}_ErrorGet(void)
{
    ${moduleGroupNameLowerCase}_client_error_t error;
    error = ${componentNameLowerCase}ErrorState;
    ${componentNameLowerCase}ErrorState = ${moduleGroupNameUpperCase}_CLIENT_ERROR_NONE;
    return error;
}

${moduleGroupNameLowerCase}_client_transfer_dir_t ${componentName}_TransferDirGet(void)
{
    return ((${moduleNameUpperCase}.SSTATUS & TWI_DIR_bm) ? ${moduleGroupNameUpperCase}_CLIENT_TRANSFER_DIR_READ : ${moduleGroupNameUpperCase}_CLIENT_TRANSFER_DIR_WRITE);
}

${moduleGroupNameLowerCase}_client_ack_status_t ${componentName}_LastByteAckStatusGet(void)
{
    return ((${moduleNameUpperCase}.SSTATUS & TWI_RXACK_bm)? ${moduleGroupNameUpperCase}_CLIENT_ACK_STATUS_RECEIVED_NACK : ${moduleGroupNameUpperCase}_CLIENT_ACK_STATUS_RECEIVED_ACK);
}

void ${componentName}_CallbackRegister(bool(*callback)(${moduleGroupNameLowerCase}_client_transfer_event_t clientEvent))
{
    if (callback != NULL)
    {
        ${componentNameUpperCase}_InterruptHandler = callback;
    }
}

static void ${componentNameUpperCase}_ErrorEventHandler(void)
{
    if (${moduleNameUpperCase}.SSTATUS & TWI_COLL_bm) {
        ${componentNameLowerCase}ErrorState = ${moduleGroupNameUpperCase}_CLIENT_ERROR_BUS_ERROR;
        ${componentNameUpperCase}_InterruptHandler(${moduleGroupNameUpperCase}_CLIENT_TRANSFER_EVENT_ERROR);
    }
    else if(${moduleNameUpperCase}.SSTATUS & TWI_BUSERR_bm)
    {
        ${componentNameLowerCase}ErrorState = ${moduleGroupNameUpperCase}_CLIENT_ERROR_COLLISION;
        ${componentNameUpperCase}_InterruptHandler(${moduleGroupNameUpperCase}_CLIENT_TRANSFER_EVENT_ERROR);
    }
}

static void ${componentNameUpperCase}_EventHandler(void)
{
    //Handling Stop Interrupt
    if((${moduleNameUpperCase}.SSTATUS & TWI_APIF_bm) && (!(${moduleNameUpperCase}.SSTATUS & TWI_AP_bm)))
    {
        ${componentNameUpperCase}_InterruptHandler(${moduleGroupNameUpperCase}_CLIENT_TRANSFER_EVENT_STOP_BIT_RECEIVED);
        ${moduleNameUpperCase}.SCTRLB = TWI_SCMD_COMPTRANS_gc;
        ${moduleNameUpperCase}.SSTATUS |=(TWI_AP_bm | TWI_APIF_bm | TWI_DIF_bm);
    }
    //Handling Address Interrupt
    else if((${moduleNameUpperCase}.SSTATUS & TWI_APIF_bm) && (${moduleNameUpperCase}.SSTATUS & TWI_AP_bm))
    {
        /* Received I2C address must be read out */
        ${componentNameLowerCase}Addr = ${componentName}_ReadAddr();

        /* Clear Software Error State */
        ${componentNameLowerCase}ErrorState = ${moduleGroupNameUpperCase}_CLIENT_ERROR_NONE;

        /* Notify that a address match event has occurred */
        if (${componentNameUpperCase}_InterruptHandler(${moduleGroupNameUpperCase}_CLIENT_TRANSFER_EVENT_ADDR_MATCH) == true)
        {
            /* TWI host wants to read */
            if (!(${moduleNameUpperCase}.SSTATUS & TWI_DIR_bm))
            {
                
                    /* In the callback, client must write to transmit register by calling I2Cx_WriteByte() */
                    if (${componentNameUpperCase}_InterruptHandler(${moduleGroupNameUpperCase}_CLIENT_TRANSFER_EVENT_TX_READY) == false)
                    {
                        ${moduleNameUpperCase}.SCTRLB = TWI_ACKACT_NACK_gc | TWI_SCMD_COMPTRANS_gc; /* Send NACK */
                    }
                
            }

            ${moduleNameUpperCase}.SCTRLB = TWI_ACKACT_ACK_gc | TWI_SCMD_RESPONSE_gc; /* Send ACK */
        }
        else
        {
            ${moduleNameUpperCase}.SCTRLB = TWI_ACKACT_NACK_gc | TWI_SCMD_COMPTRANS_gc; /* Send NACK */
        }
    }
    
    else if (${moduleNameUpperCase}.SSTATUS & TWI_DIF_bm)
    {
        /* Host reads from client, client transmits */
        if(${moduleNameUpperCase}.SSTATUS & TWI_DIR_bm)
        {

                /* TWI Host wants to read. In the callback, client must write to transmit register */
                if (${componentNameUpperCase}_InterruptHandler(${moduleGroupNameUpperCase}_CLIENT_TRANSFER_EVENT_TX_READY) == false)
                {
                    ${moduleNameUpperCase}.SCTRLB = TWI_ACKACT_NACK_gc | TWI_SCMD_COMPTRANS_gc; /* Send NACK */
                } 
                else 
                {
                    ${moduleNameUpperCase}.SCTRLB = TWI_ACKACT_ACK_gc | TWI_SCMD_RESPONSE_gc;
                }
                
        } else { 
                       
                /* TWI Host wants to write. In the callback, client must read data by calling I2Cx_ReadByte()  */
                if (${componentNameUpperCase}_InterruptHandler(${moduleGroupNameUpperCase}_CLIENT_TRANSFER_EVENT_RX_READY) == true)
                {
                    ${moduleNameUpperCase}.SCTRLB = TWI_ACKACT_ACK_gc | TWI_SCMD_RESPONSE_gc; /* Send ACK */
                }
                else
                {
                    ${moduleNameUpperCase}.SCTRLB = TWI_ACKACT_NACK_gc | TWI_SCMD_COMPTRANS_gc; /* Send NACK */
                }
        }   
    }    
}

ISR(TWI${instanceNumber}_TWIS_vect)
{
    if((${moduleNameUpperCase}.SSTATUS & TWI_COLL_bm) || (${moduleNameUpperCase}.SSTATUS & TWI_BUSERR_bm))
    {
        ${componentNameUpperCase}_ErrorEventHandler();
    }
    
    if((${moduleNameUpperCase}.SSTATUS & TWI_DIF_bm) || ((${moduleNameUpperCase}.SSTATUS & TWI_APIF_bm) && (${moduleNameUpperCase}.SSTATUS & TWI_AP_bm)) || 
           ((${moduleNameUpperCase}.SSTATUS & TWI_APIF_bm) && (!(${moduleNameUpperCase}.SSTATUS & TWI_AP_bm))) )
    {
        ${componentNameUpperCase}_EventHandler();        
    }
}

static bool ${componentNameUpperCase}_DefaultCallback(${moduleGroupNameLowerCase}_client_transfer_event_t event)
{
    /* User has to register callback. Refer example code */
    return false;
}