/**
 * \file
 * ${moduleGroupNameLowerCase}_host_event_types.h
 *
 * \defgroup
 * i2c_host_events
 *
 * \brief
 * This file contains API prototypes and other data types for ${moduleGroupNameUpperCase} driver.
 *
 * \version
 * I2C Host Driver Version ${hostDriverVersion}
 */

${disclaimer}

#ifndef ${moduleGroupNameUpperCase}_HOST_EVENT_TYPES_H
#define	${moduleGroupNameUpperCase}_HOST_EVENT_TYPES_H

#include "${moduleGroupNameLowerCase}_host_types.h"
/**
 * \brief This file contains API prototypes and data structures for I2C Host driver.
 * \ingroup i2c_host_events  I2C Host Driver
 * \{
 */

/**
 * \ingroup i2c_host_events
 * \brief
 *       I2C STATES
 */
typedef enum
{
    ${moduleGroupNameUpperCase}_STATE_IDLE = 0,
    ${moduleGroupNameUpperCase}_STATE_SEND_RD_ADDR,
    ${moduleGroupNameUpperCase}_STATE_SEND_WR_ADDR,
    ${moduleGroupNameUpperCase}_STATE_TX,
    ${moduleGroupNameUpperCase}_STATE_RX,
    ${moduleGroupNameUpperCase}_STATE_NACK,
    ${moduleGroupNameUpperCase}_STATE_ERROR,
    ${moduleGroupNameUpperCase}_STATE_STOP,
    ${moduleGroupNameUpperCase}_STATE_RESET
} ${moduleGroupNameLowerCase}_event_states_t;

/**
 * \ingroup i2c_host_events
 * \brief
 *       I2C Event Status Structure
 */
typedef struct
{
    bool busy;
    uint16_t address;
    uint8_t *writePtr;
    size_t writeLength;
    uint8_t *readPtr;
    size_t readLength;
    bool switchToRead;
    ${moduleGroupNameLowerCase}_host_error_t errorState; 
    ${moduleGroupNameLowerCase}_event_states_t state;
} ${moduleGroupNameLowerCase}_event_status_t;
/**
 * \}
 */
#endif // end of ${moduleGroupNameUpperCase}_HOST_EVENT_TYPES_H