/**
 * \file
 * ${moduleGroupNameLowerCase}_host_types.h
 *
 * \ingroup
 * i2c_host_types
 *
 * \brief
 * This file contains API prototypes and other data types for ${moduleGroupNameUpperCase} driver.
 *
 * \version
 * I2C Host Driver Version ${hostDriverVersion}
 */

${disclaimer}

#ifndef ${moduleGroupNameUpperCase}_HOST_TYPES_H
#define	${moduleGroupNameUpperCase}_HOST_TYPES_H

/**
  ${moduleGroupNameUpperCase}_ERROR Enumeration
 
  @Description
    ${moduleGroupNameUpperCase} ERROR code 
     
*/
typedef enum
{
    ${moduleGroupNameUpperCase}_ERROR_NONE,             /* No Error */
    ${moduleGroupNameUpperCase}_ERROR_ADDR_NACK,
    ${moduleGroupNameUpperCase}_ERROR_DATA_NACK,
    ${moduleGroupNameUpperCase}_ERROR_BUS_COLLISION,    /* Bus Collision Error */
}${moduleGroupNameLowerCase}_host_error_t;

/**
  ${moduleGroupNameUpperCase}_TRANSFER_SETUP structure
 
  @Description
    ${moduleGroupNameUpperCase} Clock Speed (100KHZ to 1MHZ)
     
*/
struct ${moduleGroupNameUpperCase}_TRANSFER_SETUP
{
  uint32_t clkSpeed;            // ${moduleGroupNameUpperCase} Clock Speed 
};

#endif // end of ${moduleGroupNameUpperCase}_HOST_TYPES_H